# Exercises in Chapter 2
#
# Exercise 2
#
A,E=AffineSpace(QQ,3)
Poly.<x,y,z>=PolynomialRing(QQ,3)
f=AffinityByEquations([2*x+y+2,-x+y+3*z+1,z],A)
R1=Frame(A([1,0,0]),[E([2,-1,0]),E([0,2,-1]),E([-1,0,2])])
R2=Frame(A([2,1,0]),[E([1,1,0]),E([1,-1,0]),E([0,0,1])])
H=AffinityAsMatrix(f)
M1=FrameAsMatrix(R1)
M2=FrameAsMatrix(R2)
T=M2^(-1)*H*M1
g=MatrixAsAffinity(T,A)
EquationsOfAffinity(g,Poly)
#
# Exercise 3
#
A,E=AffineSpace(QQ,2)
Poly.<x,y>=PolynomialRing(QQ,2)
r=VarietyByEquations([x+y-1],A)
s=VarietyByEquations([x-y-2],A)
G=Direction(s)
f=AffineProjection(r,G)
EquationsOfAffinity(f,Poly)
#
# Exercise 4 and 5
#
A,E=AffineSpace(QQ,3)
Poly.<x,y,z>=PolynomialRing(QQ,3)
L1=Variety(A([1,1,0]),E.subspace([E([1,2,3]),E([0,0,1])]))
L2=Variety(A([1,1,0]),E.subspace([E([3,1,1])]))
L3=Variety(A([1,1,0]),E.subspace([]))
L3=Variety(A([1,1,0]),E.subspace([]))
L4=Variety(A([1,1,0]),E)
G1=E.subspace([E([3,1,1])])
G2=E.subspace([E([1,2,3]),E([0,0,1])])
G3=E
G4=E.subspace([])
f1=Symmetry(L1,G1)
f2=Symmetry(L2,G2)
f3=Symmetry(L3,G3)
f4=Symmetry(L4,G4)
EquationsOfAffinity(f1,Poly)
EquationsOfAffinity(f2,Poly)
EquationsOfAffinity(f3,Poly)
EquationsOfAffinity(f4,Poly)
g1=AffineProjection(L1,G1)
g2=AffineProjection(L2,G2)
g3=AffineProjection(L3,G3)
g4=AffineProjection(L4,G4)
EquationsOfAffinity(g1,Poly)
EquationsOfAffinity(g2,Poly)
EquationsOfAffinity(g3,Poly)
EquationsOfAffinity(g4,Poly)
#
# Exercise 6
#
A,E=AffineSpace(QQ,3)
Poly.<x,y,z>=PolynomialRing(QQ,3)
L=VarietyByEquations([x+y+z-3,x-4*y+2*z-1],A)
M=VarietyByEquations([2*x-3*y-z-1],A)
f=Symmetry(L,Direction(M))
g=Symmetry(M,Direction(L))
EquationsOfAffinity(f,Poly)
EquationsOfAffinity(g,Poly)
#
# Exercise 8
#
A,E=AffineSpace(QQ,2)
Poly.<x,y>=PolynomialRing(QQ,2)
L1=VarietyByEquations([2*x+3*y-2],A)
L2=VarietyByEquations([x+3*y-2],A)
v1=E([1,1])
v2=E([1,0])
f1=Symmetry(L1,E.subspace([v1]))
f2=Symmetry(L2,E.subspace([v2]))
EquationsOfAffinity(f1,Poly)
EquationsOfAffinity(f2,Poly)
h1=CompositionOfAffinities(f1,f2)
h2=CompositionOfAffinities(f2,f1)
EquationsOfAffinity(h1,Poly)
EquationsOfAffinity(h2,Poly)
#
# Exercise 12
#
A,E=AffineSpace(QQ,2)
Poly.<x,y>=PolynomialRing(QQ,2)
f=AffinityByEquations([x-y+1,y+2],A)
R=Frame(A([3,2]),[E([1,-1]),E([2,1])])
H=AffinityAsMatrix(f)
M=FrameAsMatrix(R)
g=MatrixAsAffinity(M^(-1)*H*M,A)
EquationsOfAffinity(g,Poly)
#
# Exercise 13
#
A,E=AffineSpace(QQ,3)
Poly.<x,y,z>=PolynomialRing(QQ,3)
f=AffinityByEquations([1+x+2*y+z,2+y-z,-1+x+9*z],A)
IsBijective(f)
h=LinearPartOfAffinity(f); h
L=Variety(A([0,2,-1]),E.subspace([E([1,-1,0])]))
P=VarietyByEquations([2*x+y-z-1],A)
L2=ImageOfVariety(f,L)
P2=ImageOfVariety(f,P)
CartesianEquations(L2,Poly)
CartesianEquations(P2,Poly)
g=InverseOfAffinity(f)
L3=ImageOfVariety(g,L)
P3=ImageOfVariety(g,P)
FixedPoints(f)
Ref=Frame(A([1,0,4]),[E([1,1,0]),E([2,0,1]),E([8,0,7])])
H=AffinityAsMatrix(f)
M=FrameAsMatrix(Ref)
g=MatrixAsAffinity(M^(-1)*H*M,A)
EquationsOfAffinity(g,Poly)
#
# Exercise 15
#
A,E=AffineSpace(QQ,3)
Poly.<x,y,z>=PolynomialRing(QQ,3)
f=AffinityByEquations([1-x/3+(2/3)*y+(2/3)*z,(2/3)*x-y/3+(2/3)*z,-1+(2/3)*x+(2/3)*y-z/3],A)
FixedPoints(f)
SpecialInvariantLines(f)
L=Variety(A([0,2,-1]),E.subspace([E([1,2,3])]))
Y=ImageOfVariety(f,L)
CartesianEquations(Y,Poly)
g=InverseOfAffinity(f)
Z=VarietyByEquations([x-y-z-2],A)
W=ImageOfVariety(g,Z)
CartesianEquations(W,Poly)
#
# Exercise 20
#
var('a')
A,E=AffineSpace(SR,4)
Poly.<x,y,z,t>=PolynomialRing(SR,4)
f=AffinityByEquations([1+x+y,-1+y+z,2+z+t,1+a*x+t],A)
IsBijective(f)
g=InverseOfAffinity(f)
AffinityAsMatrix(g)
  
  
  
  




























