# Exercises in Chapters 3 and 4
#
# Chapter 
#
# Exercise 3.8
#
A,E=AffineSpace(QQ,2)
Poly.<x,y>=PolynomialRing(QQ,2)
f=AffinityByEquations([x-(1/8)*y-(1/8),2*x-(1/8)],A)
N,P=NormalFormOfAffinity(f,transformation=True)
FixedPoints(f)
SpecialInvariantLines(f)
M=LinearPartOfAffinity(f).matrix().transpose()
V=(M-(1/2)*identity_matrix(2)).right_kernel()
L=Variety(FixedPoints(f)[0],V)
AffineDimension(L)
IsInvariant(L,f)
CartesianEquations(L,Poly)
AffinityAsMatrix(P)
AffinityAsMatrix(Conjugate(f,P))
Name(f)
#
# Exercise 3.9
#
A,E=AffineSpace(QQ,2)
Poly.<x,y>=PolynomialRing(QQ,2)
fa=AffinityByEquations([4*y+1,-x+4*y+1],A)
fb=AffinityByEquations([2*x+9*y+12,x+4*y+4],A)
fc=AffinityByEquations([-(1/2)*x+(3/2)*y+(11/2),(3/2)*x-(1/2)*y-(7/2)],A)
fd=AffinityByEquations([2*x-y-2,3*y+2],A)
fe=AffinityByEquations([(3/2)*x-(1/2)*y-1,(1/2)*x+(1/2)*y+1],A)
ff=AffinityByEquations([x+3*y+3,x-2*y+2],A)
#
f=fa
Name(f)
NormalFormOfAffinity(f)
FixedPoints(f)
SpecialInvariantLines(f)
M=LinearPartOfAffinity(f).matrix().transpose()
V=(M-2*identity_matrix(2)).right_kernel()
L=Variety(FixedPoints(f)[0],V)
AffineDimension(L)
IsInvariant(L,f)
CartesianEquations(L,Poly)
N,P=NormalFormOfAffinity(f,transformation=True)
AffinityAsMatrix(P)
AffinityAsMatrix(Conjugate(f,P))
#
f=fc
Name(f)
NormalFormOfAffinity(f)
FixedPoints(f)
SpecialInvariantLines(f)
N,P=NormalFormOfAffinity(f,transformation=True)
AffinityAsMatrix(P)
AffinityAsMatrix(Conjugate(f,P))
#
f=fd
Name(f)
NormalFormOfAffinity(f)
FixedPoints(f)
SpecialInvariantLines(f)
M=LinearPartOfAffinity(f).matrix().transpose()
V1=(M-3*identity_matrix(2)).right_kernel()
L1=Variety(FixedPoints(f)[0],V1)
V2=(M-2*identity_matrix(2)).right_kernel()
L2=Variety(FixedPoints(f)[0],V2)
AffineDimension(L1)
AffineDimension(L2)
IsInvariant(L1,f)
IsInvariant(L2,f)
CartesianEquations(L1,Poly)
CartesianEquations(L2,Poly)
N,P=NormalFormOfAffinity(f,transformation=True)
AffinityAsMatrix(P)
AffinityAsMatrix(Conjugate(f,P))
#
f=fe 
Name(f)
NormalFormOfAffinity(f)
FixedPoints(f)
SpecialInvariantLines(f)
N,P=NormalFormOfAffinity(f,transformation=True)
AffinityAsMatrix(P)
AffinityAsMatrix(Conjugate(f,P))
#
A,E=AffineSpace(AA,2)
Poly.<x,y>=PolynomialRing(AA,2)
fb=AffinityByEquations([2*x+9*y+12,x+4*y+4],A)
ff=AffinityByEquations([x+3*y+3,x-2*y+2],A)
#
f=fb
Name(f)
NormalFormOfAffinity(f)
FixedPoints(f)
N,P=NormalFormOfAffinity(f,transformation=True)
M=LinearPartOfAffinity(f).matrix().transpose()
V1=(M-N[0,0]*identity_matrix(2)).right_kernel()
L1=Variety(FixedPoints(f)[0],V1)
V2=(M-N[1,1]*identity_matrix(2)).right_kernel()
L2=Variety(FixedPoints(f)[0],V2)
AffineDimension(L1)
AffineDimension(L2)
IsInvariant(L1,f)
IsInvariant(L2,f)
CartesianEquations(L1,Poly)
CartesianEquations(L2,Poly)
AffinityAsMatrix(P)
N==AffinityAsMatrix(Conjugate(f,P))
#
f=ff
Name(f)
NormalFormOfAffinity(f)
FixedPoints(f)
N,P=NormalFormOfAffinity(f,transformation=True)
M=LinearPartOfAffinity(f).matrix().transpose()
V1=(M-N[0,0]*identity_matrix(2)).right_kernel()
L1=Variety(FixedPoints(f)[0],V1)
V2=(M-N[1,1]*identity_matrix(2)).right_kernel()
L2=Variety(FixedPoints(f)[0],V2)
AffineDimension(L1)
AffineDimension(L2)
IsInvariant(L1,f)
IsInvariant(L2,f)
CartesianEquations(L1,Poly)
CartesianEquations(L2,Poly)
AffinityAsMatrix(P)
N==AffinityAsMatrix(Conjugate(f,P))
#
# Exercise 3.12
#
A,E=AffineSpace(AA,2)
Poly.<x,y>=PolynomialRing(AA,2)
Aa=matrix(AA,[[-17,10],[30,18]])
Ab=matrix(AA,[[-4,1],[-9,-2]])
Ac=matrix(AA,[[11,-25],[4,-9]])
Ad=matrix(AA,[[11,-25],[4,-9]])
Ae=matrix(AA,[[-7,-4],[12,7]])
Af=matrix(AA,[[4,6],[-2,-3]])
aa=A([-2,4])
ab=A([-2,2])
ac=A([-5,-2])
ad=A([-39,-13])
ae=A([2,-3])
af=A([-9,6])
fa=Affinity(A,aa,Hom(E,E)(Aa))
fb=Affinity(A,ab,Hom(E,E)(Ab))
fc=Affinity(A,ac,Hom(E,E)(Ac))
fd=Affinity(A,ad,Hom(E,E)(Ad))
fe=Affinity(A,ae,Hom(E,E)(Ae))
ff=Affinity(A,af,Hom(E,E)(Af))
#
Name(fa)
FixedPoints(fa)
N,g=NormalFormOfAffinity(fa,transformation=True)
N
Symbolize(NormalFormOfAffinity(fa),size='matrix')
SparseInvariantLines(fa)
SpecialInvariantLines(fa)
AffinityAsMatrix(g)
N==AffinityAsMatrix(Conjugate(fa,g))
#
Name(fb)
FixedPoints(fb)
N,g=NormalFormOfAffinity(fb,transformation=True)
N
SparseInvariantLines(fb)
SpecialInvariantLines(fb)
AffinityAsMatrix(g)
N==AffinityAsMatrix(Conjugate(fb,g))
#
Name(fc)
FixedPoints(fc)
N,g=NormalFormOfAffinity(fc,transformation=True)
N
SparseInvariantLines(fc)
SpecialInvariantLines(fc)
AffinityAsMatrix(g)
N==AffinityAsMatrix(Conjugate(fc,g))
#
Name(fd)
FixedPoints(fd)
N,g=NormalFormOfAffinity(fd,transformation=True)
N
SparseInvariantLines(fd)
SpecialInvariantLines(fd)
AffinityAsMatrix(g)
N==AffinityAsMatrix(Conjugate(fd,g))
#
Name(fe)
FixedPoints(fe)
N,g=NormalFormOfAffinity(fe,transformation=True)
N
SparseInvariantLines(fe)
SpecialInvariantLines(fe)
AffinityAsMatrix(g)
N==AffinityAsMatrix(Conjugate(fe,g))
#
Name(ff)
FixedPoints(ff)
N,g=NormalFormOfAffinity(ff,transformation=True)
N
SparseInvariantLines(ff)
SpecialInvariantLines(ff)
AffinityAsMatrix(g)
N==AffinityAsMatrix(Conjugate(ff,g))
#
# Chapter 4
#
# Exercise 4.3
#
A,E=AffineSpace(AA,3)
Poly.<x1,x2,x3>=PolynomialRing(AA,3)
f=AffinityByEquations([3*x1+x2-x3+1,x1+8,x1+x2+x3],A)
InvarianceLevel(f)
K=NormalFormOfAffinity(f)
Symbolize(K,size='matrix')
#
# Exercise 4.4
#
A,E=AffineSpace(QQ,4)
M=matrix(QQ,[[1,0,0,0,2],[1,1,0,0,3],[0,0,2,0,1],[0,0,0,3,3],[0,0,0,0,1]])
f=MatrixAsAffinity(M,A)
InvarianceLevel(f)
NormalFormOfAffinity(f)
#
# Exercise 4.5
#
A,E=AffineSpace(QQ,4)
M=matrix(QQ,[[-1,-4,0,0,1],[1,3,0,0,2],[0,0,1,0,3],[0,0,1,1,4],[0,0,0,0,1]])
f=MatrixAsAffinity(M,A)
InvarianceLevel(f)
NormalFormOfAffinity(f)
#
# Exercise 4.6
#
A,E=AffineSpace(QQ,3)
M=matrix(QQ,[[-1,-4,0,1],[1,3,0,2],[0,0,2,3],[0,0,0,1]])
f=MatrixAsAffinity(M,A)
InvarianceLevel(f)
NormalFormOfAffinity(f)



























