#
# Exercise 5.3
#
A,E=AffineSpace(QQ,3)
Poly.<x,y,z>=PolynomialRing(QQ,3)
L1=VarietyByEquations([x+y+z-2,x-y+z-1],A)
L2=Variety(A([0,3,4]),E.subspace([E([2,2,3]),E([1,2,2])]))
P=A([0,0,0])
d1,Q1,R1=SquareDistance(P,L1,points=True)
d2,Q2,R2=SquareDistance(P,L2,points=True)
#
# Exercise 5.4
#
A,E=AffineSpace(QQ,4)
Poly.<x,y,z,t>=PolynomialRing(QQ,4)
P=A([1,1,1,1])
Pi=VarietyByEquations([x-y,x+t-3],A)
T=OrthogonalVariety(P,Pi)
CartesianEquations(T,Poly)
#
# Exercise 5.5
#
M=matrix(QQ,[[5,1,0],[1,1,0],[0,0,3]])
Af,E=AffineSpace(QQ,3,metric=M)
P=Af([-1,1,-2])
A=PointAsVariety(Af([1,-1,1]))
B=PointAsVariety(Af([-2,1,3]))
C=PointAsVariety(Af([4,-5,-2]))
T=AffineSum([A,B,C])
d,R,S=SquareDistance(P,T,points=True)
#
# Exercise 5.6
#
M=matrix(QQ,[[5,1,0,1],[1,1,0,0],[0,0,3,0],[1,0,0,1]])
Af,E=AffineSpace(QQ,4,metric=M)
Poly.<x,y,z,t>=PolynomialRing(QQ,4)
La=VarietyByEquations([x+y-z-1,2*x+t-2,2*x+y-z+t],Af)
X=PointAsVariety(Af([0,1,1,0]))
Y=PointAsVariety(Af([1,1,1,1]))
Z=PointAsVariety(Af([-1,0,0,1]))
Ta=AffineSum([X,Y,Z])
SquareDistance(La,Ta)
Tb1=VarietyByEquations([x+y-z,2*x+t-3],Af)
Tb2=VarietyByEquations([x+y+z+t-2,4*x+2*y+2*t],Af)
SquareDistance(Tb1,Tb2)
Lc1=Variety(Af([1,-1,0,0]),E.subspace([E([0,1,0,1])]))
Lc2=VarietyByEquations([x+y-2*z-2,y+z+t-3,x+z+1],Af)
SquareDistance(Lc1,Lc2)
#
# Exercise 5.7
#
A,E=AffineSpace(QQ,4)
Poly.<x,y,z,t>=PolynomialRing(QQ,4)
Pi1=VarietyByEquations([x-t-2,y-z+2],A)
Pi2=VarietyByEquations([x-z-2,y-t+1],A)
SquareDistance(Pi1,Pi2,points=True)
M=matrix(QQ,[[5,1,0,1],[1,1,0,0],[0,0,3,0],[1,0,0,1]])
A,E=AffineSpace(QQ,4,metric=M)
Pi1=VarietyByEquations([x-t-2,y-z+2],A)
Pi2=VarietyByEquations([x-z-2,y-t+1],A)
SquareDistance(Pi1,Pi2,points=True)
#
# Exercise 5.8
#
A,E=AffineSpace(QQ,4)
Poly.<x,y,z,t>=PolynomialRing(QQ,4)
Pi=VarietyByEquations([x-t-2,y-z+2],A)
L=VarietyByEquations([x-z-2,y-t+1,y],A)
SquareDistance(Pi,L,points=True)
M=matrix(QQ,[[5,1,0,1],[1,1,0,0],[0,0,3,0],[1,0,0,1]])
A,E=AffineSpace(QQ,4,metric=M)
Pi=VarietyByEquations([x-t-2,y-z+2],A)
L=VarietyByEquations([x-z-2,y-t+1,y],A)
SquareDistance(Pi,L,points=True)
#
# Exercise 5.9
#
A,E=AffineSpace(QQ,4)
Poly.<x,y,z,t>=PolynomialRing(QQ,4)
Pi=VarietyByEquations([2*x-3*z-2,y-3*t-1],A)
r=Variety(A([1,2,3,1]),E.subspace([E([0,3,2,1])]))
SquareDistance(Pi,r,points=True)
#
# Exercise 5.10
#
A,E=AffineSpace(QQ,3)
Poly.<x,y,z>=PolynomialRing(QQ,3)
r=VarietyByEquations([x-1+y,x-1-z],A)
s=VarietyByEquations([x-y,x-z],A)
d,P,Q=SquareDistance(r,s,points=True)
L=AffineSum([PointAsVariety(P),PointAsVariety(Q)])
AreOrthogonal(L,r)
AreOrthogonal(L,s)
M=matrix(QQ,[[5,1,0],[1,1,0],[0,0,3]])
A,E=AffineSpace(QQ,3,metric=M)
r=VarietyByEquations([x-1+y,x-1-z],A)
s=VarietyByEquations([x-y,x-z],A)
d,P,Q=SquareDistance(r,s,points=True)
L=AffineSum([PointAsVariety(P),PointAsVariety(Q)])
AreOrthogonal(L,r)
AreOrthogonal(L,s)
#
# 


  
   

    
  
  
  












   

